#! /bin/bash
logger -t webapp "uncmpressConfigFile.sh"

# chooystickのモデル番号
# 最新のモデル番号
CHOYSTICK_LAST_MODEL_NUMBER=2
# 一番古いモデル番号
CHOYSTICK_OLDEST_MODEL_NUMBER=2


TMP_DIR=/tmp
CHOY_DIR=/opt/piLab
CHOYSTICK_DIR=$TMP_DIR/choystick_2
WORK_DIR=$CHOYSTICK_DIR/config
COMPRESS_FILE=$TMP_DIR/choystick_2.zip
CHOY_CONFIG_DIR=$CHOY_DIR/config
CHOY_CONFIG_ORG_DIR=$CHOY_DIR/config.org
CHOY_CONFIG_BAK_DIR=$TMP_DIR/config_bak
CHOY_UI_DIR=$CHOY_DIR/ui
DONT_REMOVE_FILE_LIST=$CHOY_DIR/dont_remove.list

### 削除対象外のconfig以外を除
if [ ! -e $CHOY_CONFIG_BAK_DIR ]; then
	mkdir $CHOY_CONFIG_BAK_DIR
fi

# 対象外のリストから一致するconfigを一時的に移動
for confFile in `cat $DONT_REMOVE_FILE_LIST`
do
	if [ -e $CHOY_CONFIG_DIR/$confFile ]; then
		sudo mv $CHOY_CONFIG_DIR/$confFile $CHOY_CONFIG_BAK_DIR/$confFile
	fi
done
# config以下削除
sudo rm $CHOY_CONFIG_DIR/*
# 一時的に移動したconfigを元に戻す
sudo mv $CHOY_CONFIG_BAK_DIR/* $CHOY_CONFIG_DIR/

if [ -e $CHOY_CONFIG_BAK_DIR ]; then
#	sudo rm -fr $CHOY_CONFIG_BAK_DIR/
	rm -fr $CHOY_CONFIG_BAK_DIR/
fi

### アップロードしたconfigを展開
cd $TMP_DIR
unzip $COMPRESS_FILE > /dev/null

# 最新のモデルから設定ファイルのディレクトリを検索
# 見つからなければ下位モデルのディレクトリを検索していく
for no in `seq $CHOYSTICK_LAST_MODEL_NUMBER -1 $CHOYSTICK_OLDEST_MODEL_NUMBER`
do
	CHOYSTICK_DIR=`printf "%s/choystick_%d" $TMP_DIR $no`
	WORK_DIR=`printf "%s/config" $CHOYSTICK_DIR`
	if [ -e $WORK_DIR ]; then
		break
	fi
done

sudo chown www-data:www-data $WORK_DIR/* 

sudo mv $WORK_DIR/* $CHOY_CONFIG_DIR/
#不足ファイルがある場合は、初期データをコピー
sudo cp -an $CHOY_CONFIG_ORG_DIR/* $CHOY_CONFIG_DIR/

sudo chmod 666 $CHOY_CONFIG_DIR/*
sudo chown www-data:www-data $CHOY_CONFIG_DIR/* 

if [ -e $CHOY_CONFIG_DIR/gtkrc.conf ]; then
	sudo cp -f $CHOY_CONFIG_DIR/gtkrc.conf $CHOY_UI_DIR/gtkrc
fi

sudo rm -fr $COMPRESS_FILE $CHOYSTICK_DIR
