#! /bin/bash
LOGGER="logger -t web-upload "
CHOY_PKG=/opt/installer/choy/choystick.tar.gz
CHOY_EVENT_FILE=/opt/installer/INSTALLCHOY
CHKTMP_DIR=/tmp/choy
CHECKSUM_FILE=choystick.txt
DEFAULT_DIR=`pwd`
STAT=1
if [ -e $CHOY_PKG ] ; then
	mkdir -p $CHKTMP_DIR
	tar zxvfp $CHOY_PKG -C $CHKTMP_DIR > /dev/null
	cd $CHKTMP_DIR
	if [ -e $CHECKSUM_FILE ]; then
		md5sum -c $CHECKSUM_FILE > /dev/null
		if [ $? -eq 0 ]; then
			$LOGGER "Software Validation : OK"
			STAT=0
		else
			$LOGGER "Software Validation : NG"
		fi
	else
		$LOGGER "NOT FOUND MD5SUM.TXT. Software Validation will be ABORTED"
	fi

	cd $DEFAULT_DIR
	rm -rf $CHKTMP_DIR
fi
exit $STAT
