<?php
require('validate.php');
require('files.php');
require('unitSetting.php');

$xml = "../../config/Aileuns.xml"; //ファイルを指定
$doc = simplexml_load_file($xml);
$array = array(
	"message" => "" ,
	"status" => 0 ,
);

foreach ($doc->Aileun as $aileun) {
	$id = (string)$aileun['id'];
	$key = 'aileun' . $id . '_ipaddr';
	if (isset($_POST[$key])) {		// IPパラメタがあれば更新処理をする
		// エルーア設定データが全て揃っているか確認
		$aileunParamKeyTmps = array('aileun' . $id . '_ipaddr', 'aileun' . $id . '_http_port', 'aileun' . $id . '_user', 'aileun' . $id . '_password');
		if (validateParams($_POST, $aileunParamKeyTmps)) {
			$value = $_POST[$key];
			$isEnable = strlen($value) > 0;
			if ($isEnable) {
				$value = $_POST[$aileunParamKeyTmps[0]];
				if ((isIpV4Format($value) && validateUnitIpv4Addr($value))
					|| (!isIpV4Format($value) && validateUri($value))
				) {
					$aileun->IpAddr = $value;
				} else {
					$array["message"] = "エルーア" . str_pad($id, 2, 0, STR_PAD_LEFT) . "　アドレスが不正です";
					$array["status"] = 1;
					goto response;
				}

				$value = $_POST[$aileunParamKeyTmps[1]];
				if (validatePortNumber($value)) {
					$portNum = intval($value);
					$aileun->HttpPort = (string)$portNum;
				} else {
					$array["message"] = "エルーア". str_pad($id, 2, 0, STR_PAD_LEFT) ."　HTTPポートが不正です" ;
					$array["status"] = 1 ;
					goto response;
				}


				$value = $_POST[$aileunParamKeyTmps[2]];
				$aileun->UserID = $value;
				if (validateAileunUserId($value)) {
					$aileun->UserID = $value;
				} else {
					$array["message"] = "エルーア". str_pad($id, 2, 0, STR_PAD_LEFT) ."　ユーザー名が不正です" ;
					$array["status"] = 1 ;
					goto response;
				}

				$value = $_POST[$aileunParamKeyTmps[3]];
				if (validateAileunPassword($value)) {
					$aileun->Password = $value;
				} else {
					$array["message"] = "エルーア". str_pad($id, 2, 0, STR_PAD_LEFT) ."　パスワードが不正です" ;
					$array["status"] = 1 ;
					goto response;
			}
			} else {
				$aileun->IpAddr = "";
				$aileun->HttpPort = 80;
				$aileun->UserID = "";
				$aileun->Password = "";
			}
		}
	}
}
$doc->saveXML($xml);
exec("../../cmd/apps_restart.sh > /dev/null &");

response:
$json = json_encode( $array ) ;
header( "Content-Type: application/json; charset=utf-8" );
echo $json;

