<?php
require('validate.php');
require('../comConst.php');
require('files.php');
require('unitSetting.php');

$xml = "../../config/Cameras.xml"; //ファイルを指定
$doc = simplexml_load_file($xml);
$array = array(
	"message" => "" ,
	"status" => 0 ,
);

foreach ($doc->Camera as $camera) {
	$id = (string)$camera['id'];
	$key = 'cam' . $id . '_ipaddr';
	if (isset($_POST[$key])) {		// IPパラメタがあれば更新処理をする
		// カメラ設定データが全て揃っているか確認
		$cameraParamKeyTmps = array('cam' . $id . '_ipaddr', 'cam' . $id . '_http_port', 'cam' . $id . '_user', 'cam' . $id . '_password', 'cam' . $id . '_maker',  'cam' . $id . '_pan', 'cam' . $id . '_tilt');
		if (validateParams($_POST, $cameraParamKeyTmps)) {
			$value = $_POST[$key];
			$isEnable = strlen($value) > 0;
			if ($isEnable) {
				$value = $_POST[$cameraParamKeyTmps[0]];
				if ((isIpV4Format($value) && validateUnitIpv4Addr($value))
					|| (!isIpV4Format($value) && validateUri($value))){
					$camera->IpAddr = $value;
				}
				else{
					$array["message"] = "カメラ". str_pad($id, 2, 0, STR_PAD_LEFT) ."　アドレスが不正です" ;
					$array["status"] = 1 ;
					goto response;	
				}

				$value = $_POST[$cameraParamKeyTmps[1]];
				if (validatePortNumber($value)) {
					$portNum = intval($value);
					$camera->HttpPort = (string)$portNum;
				} else {
					$array["message"] = "カメラ". str_pad($id, 2, 0, STR_PAD_LEFT) ."　HTTPポートが不正です" ;
					$array["status"] = 1 ;
					goto response;
				}


				$value = $_POST[$cameraParamKeyTmps[2]];
				$camera->UserID = $value;
				if (validateCameraUserId($value)) {
					$camera->UserID = $value;
				} else {
					$array["message"] = "カメラ". str_pad($id, 2, 0, STR_PAD_LEFT) ."　ユーザー名が不正です" ;
					$array["status"] = 1 ;
					goto response;
				}
				if(strlen($camera->UserID) > 0){
					$value = $_POST[$cameraParamKeyTmps[3]];
					if (validateCameraPassword($value)) {
						$camera->Password = $value;
					} else {
						$array["message"] = "カメラ". str_pad($id, 2, 0, STR_PAD_LEFT) ."　パスワードが不正です" ;
						$array["status"] = 1 ;
						goto response;
					}	
				}
				else{
					$camera->Password = "";
				}

				$value = $_POST[$cameraParamKeyTmps[4]];
				if (validateMaker($value, $makers)) {
					$camera->Maker = $value;
				} else {
					$array["message"] = "カメラ". str_pad($id, 2, 0, STR_PAD_LEFT) ."　メーカーが不正です" ;
					$array["status"] = 1 ;
					goto response;
				}

				$value = $_POST[$cameraParamKeyTmps[5]];
				if (validateBool($value)) {
					$camera->PanInversion = $value;
				} else {
					$array["message"] = "カメラ". str_pad($id, 2, 0, STR_PAD_LEFT) ."　パン反転が不正です" ;
					$array["status"] = 1 ;
					goto response;
				}

				$value = $_POST[$cameraParamKeyTmps[6]];
				if (validateBool($value)) {
					$camera->TiltInversion = $value;
				} else {
					$array["message"] = "カメラ". str_pad($id, 2, 0, STR_PAD_LEFT) ."　反転が不正です" ;
					$array["status"] = 1 ;
					goto response;
				}
			} else {
				$camera->IpAddr = "";
				$camera->HttpPort = 80;
				$camera->UserID = "";
				$camera->Password = "";
				$camera->Maker = "Panasonic1";
				$camera->PanInversion = "false";
				$camera->TiltInversion = "false";
			}
		}
	}
}
$doc->saveXML($xml);
exec("../../cmd/apps_restart.sh > /dev/null &");

response:
$json = json_encode( $array ) ;
header( "Content-Type: application/json; charset=utf-8" );
echo $json;
