<?php
require('comConst.php');

$xml = "../config/Cameras.xml"; //ファイルを指定
$xmlData = simplexml_load_file($xml); //xmlを読み込む
$jsonCamera = array();
$jsonList = array();

$base_camera = $_GET['cam_base'];
$chCount = exec("../cmd/getCameraCount.sh");

if($chCount == 99){
	$camera_count = 20;
	$endIndex = $base_camera + $camera_count - 1;
	if ($endIndex > 99) {
		$endIndex = 99;
		$camera_count = $endIndex - $base_camera + 1;
	}	
}
else if($chCount == 36){
	$camera_count = 18;
	$endIndex = $base_camera + $camera_count - 1;
	if ($endIndex > 36) {
		$endIndex = 36;
		$camera_count = $endIndex - $base_camera + 1;
	}
}
else if($chCount == 16){
	$camera_count = 16;
	$endIndex = 16;
}
else{
	$camera_count = 4;
	$endIndex = 4;
}

// 空要素を生成(xmlのデータなしのケースでもデータを返信する)
$emptyCamera = array('id' => '1', 'IpAddr' => '', 'HttpPort' => '80', 'UserID' => '', 'Password' => '', 'Maker' => 'Panasonic1', 'PanInversion' => 'false', 'TiltInversion' => 'false');
for ($index = $base_camera; $index <= $endIndex; $index++) {
	$emptyCamera['id'] = $index;
	$jsonList[$index] = $emptyCamera;
}

foreach ($xmlData as $camera) {
	/// ID
	foreach ($camera->attributes() as $key => $value) {
		$jsonCamera[$key] = (string)$value;
	}
	foreach ($camera->children() as $key => $value) {
		$jsonCamera[$key] = (string)$value;
	}
	if ($base_camera <= $jsonCamera['id'] && $jsonCamera['id'] <= $endIndex) {
		$jsonList[$jsonCamera['id']] = $jsonCamera;
	}
}
print('<input id="cam_base" type="hidden" value="' . $base_camera . '"/>' . PHP_EOL);
print('<input id="cam_num" type="hidden" value="' . $camera_count . '"/>' . PHP_EOL);

$boolParams = array('false' => 'しない', 'true' => 'する');
foreach ($jsonList as $camera) {
	$makerSelect = array();
	print('<p class="table_title">カメラ' . str_pad($camera['id'], 2, 0, STR_PAD_LEFT) . '</p>' . PHP_EOL);
	print('<table border="2" width="750px">' . PHP_EOL);
	print('<tr>' . PHP_EOL);
	print('<th>メーカー</th>' . PHP_EOL);
	print('<td colspan="2">' . PHP_EOL);
	print('<select id="cam' . $camera['id'] . '_maker" value="' . $camera['Maker'] . '">' . PHP_EOL);
	foreach ($makers as $key => $value) {
		if ($key == $camera['Maker']) {
			print('<option value="' . $key . '" selected>' . $value . '</option>' . PHP_EOL);
		} else {
			print('<option value="' . $key . '">' . $value . '</option>' . PHP_EOL);
		}
	}
	print('</select></td></tr>' . PHP_EOL);
	print('<tr>' . PHP_EOL);
	print('<th>アドレス</th>' . PHP_EOL);
	print('<td colspan="2">' . PHP_EOL);
	print('<input class="input-xxlarge" type="text" width="300px" id="cam' . $camera['id'] . '_ipaddr" maxlength="253"  value="' . $camera['IpAddr'] . '"/>' . PHP_EOL);
	print('</td></tr>' . PHP_EOL);
	print('<tr>' . PHP_EOL);
	print('<th>HTTPポート</th>' . PHP_EOL);
	print('<td colspan="2">' . PHP_EOL);
	print('<input class="positive-integer input-mini" type="text" width="300px" id="cam' . $camera['id'] . '_http_port" maxlength="5"  value="' . $camera['HttpPort'] . '"/>' . PHP_EOL);
	print('</td></tr>' . PHP_EOL);
	print('<th>ユーザー名</th>' . PHP_EOL);
	print('<td colspan="2">' . PHP_EOL);
	print('<input type="text" id="cam' . $camera['id'] . '_user" maxlength="32"  value="' . $camera['UserID'] . '"/>' . PHP_EOL);
	print('</td></tr>' . PHP_EOL);
	print('<th>パスワード</th>' . PHP_EOL);
	print('<td colspan="2">' . PHP_EOL);
	print('<input type="password" id="cam' . $camera['id'] . '_password" maxlength="32"  value="' . $camera['Password'] . '"/>' . PHP_EOL);
	print('</td></tr>' . PHP_EOL);
	print('<th style="width: 130px;">パン・チルト反転</th>' . PHP_EOL);
	print('<td>パン反転' . PHP_EOL);
	print('<select style="width: 150px;" id="cam' . $camera['id'] . '_pan" value="' . $camera['PanInversion'] . '">' . PHP_EOL);
	foreach ($boolParams as $key => $value) {
		if ($key == $camera['PanInversion']) {
			print('<option value="' . $key . '" selected>' . $value . '</option>' . PHP_EOL);
		} else {
			print('<option value="' . $key . '">' . $value . '</option>' . PHP_EOL);
		}
	}
	print('</select></td>' . PHP_EOL);
	print('<td>チルト反転' . PHP_EOL);
	print('<select style="width: 150px;" id="cam' . $camera['id'] . '_tilt" value="' . $camera['TiltInversion'] . '">' . PHP_EOL);
	foreach ($boolParams as $key => $value) {
		if ($key == $camera['TiltInversion']) {
			print('<option value="' . $key . '" selected>' . $value . '</option>' . PHP_EOL);
		} else {
			print('<option value="' . $key . '">' . $value . '</option>' . PHP_EOL);
		}
	}
	print('</select></td></tr></table>' . PHP_EOL);
}
print('<br><br><br>'  . PHP_EOL);
print('<footer><div class="button_place"><button type="button" class="btn btn-primary btn-lg" style="margin-right: 5px;" id="camera_setting">設定</button><button type="button" class="btn btn-primary btn-lg" style="margin-left: 5px;" id="clear_setting">クリア</button></div></footer>');
